#include <cmath>
#include <iostream>
#include "template.hpp"
#include "complexe.hpp"

using namespace std;

int main (){

  int maxint =0;
  int * tabint;
  tabint = new int[4];
  tabint[0]=1; tabint[1]=3;
  tabint[2]=8; tabint[3]=12;
  maxint = max(4,tabint);
  cout<<" max int: "<<maxint<<endl;

  double maxdouble =0.0;
  double * tabdouble;
  tabdouble = new double[4];
  tabdouble[0]=1.0; tabdouble[1]=3.2;
  tabdouble[2]=1.4; tabdouble[3]=-1.5;
  maxdouble = max(4,tabdouble);
  cout<<" max double: "<<maxdouble<<endl;

  maxint =0.0;
  maxloc(tabint[0],tabint[2],maxint);
  cout<<" max int: "<<maxint<<endl;

  maxdouble =0.0;
  maxloc<double>(tabint[0],tabdouble[0],maxdouble);
  cout<<" max double: "<<maxdouble<<endl;
  
  complexe maxcomp(0,0);
  complexe * tabcomp ;
  tabcomp = new complexe[4];
  tabcomp[0]=complexe(1.0,-1.0);
  tabcomp[1]=complexe(0.5,2.0);
  tabcomp[2]=complexe(0.0,2.0);
  tabcomp[3]=complexe(0.5,0.0);
  maxcomp = max(4,tabcomp);
  cout<<" max comp: "<<maxcomp<<endl;

  maxint = 0;
  maxcomp = complexe(0.0,0.0);
  max2(5,tabint,tabcomp,maxint,maxcomp);
  cout<<" max int: "<<maxint<<" max comp: "<<maxcomp<<endl;

  maxloc(tabint[0],tabint[2],maxint);
  cout<<" max int: "<<maxint<<endl;
  maxloc(tabint[0],&tabint[2],maxint);
  cout<<" max int: "<<maxint<<endl;
  maxloc(tabint[0],tabint[2],tabint[1],maxint);
  cout<<" max int: "<<maxint<<endl;

  complexe c;
  maxloc(tabcomp[0],tabcomp[1],c);
  cout<<"c >>> "<<c<<endl;
  
  printclass<int>();
  printclass<double>();
  return 0;
};

