#ifndef TEMPLATE_HPP
#define TEMPLATE_HPP

#include <cmath>
#include <iostream>
#include <string.h>
#include <type_traits>
#include "complexe.hpp"
using namespace std;


template <class T> T max (int n, T * tab){
  T max = tab[0];
  for (int i=0;i<n;i++){
    if( tab[i] > max ) { max = tab[i]; }
  }
  return max;
}


template <class T1, class T2> int max2 (int n, T1 * tab, T2 * tab2, T1 & maxT1, T2 & maxT2){
  maxT1 = tab[0];
  for (int i=0;i<n;i++){ if( tab[i] > maxT1 ) { maxT1 = tab[i]; } }
  maxT2 = tab2[0];
  for (int i=0;i<n;i++){ if( tab2[i] > maxT2 ) { maxT2 = tab2[i]; } }
  return 1;
}


template <class T> int maxloc (T t1, T t2, T &m1){
  m1 = t2;
  if( t1 > t2 ) { m1 = t1; }
  return 1;
}

int maxloc(complexe t1, complexe t2, complexe & m){
  m=t2;
  if( t1.reel() > t2.reel() ) { m=t1; }
  return 1;
}

template <class T> int maxloc (T t1, T * t2, T &m1){
  m1 = *t2;
  if( t1 > *t2 ) { m1 = t1; }
  return 1;
}

template <class T> int maxloc (T t1, T t2, T t3, T &m1){
  m1 = t2;
  if( t1 > t2 ) { m1 = t1; }
  if( t3 > m1 ) { m1 = t3; }
  return 1;
}

template <class T> void printclass(){
  if (std::is_same<T, double>::value){
    cout<<" the class is a double "<<endl;
  }
  else {
    cout<<" the class is not a double "<<endl;
  }

}


#endif
